#ifndef HORIZONTAL_PROBLEM_HPP
#define HORIZONTAL_PROBLEM_HPP

#include "geometry.hpp"
#include "physics.hpp"


namespace Kernel{
  /*! Class for Horzontal problem.
   *! Here we code only homogeneus Neumann conditions.
  */
  class HorizontalProblem{
  private:
    const Geometry* geometry;
    double* sup_M;
    double* diag_M;
    double* sub_M;
    double* F;
    void solve_system();
    double compute_error();
  public:
    //Input
    double* previous_hydr;
    double* l;
    double* Pl;
    //Output
    double* hydr;
    double error;

    HorizontalProblem();

    void init(const Geometry* geometry);

    void run();
  };

  inline HorizontalProblem::HorizontalProblem(){
  }



}

#endif
